macroScript VRayRTAnimPreview
enabledIn:#("max")
category:"VRay"
buttontext:"Make V-Ray RT Preview Animation"
tooltip:"Render an animation preview with V-Ray RT"
(
try(destroydialog SettingsRollout)catch()	

	global SettingsRollout
	global enabled = false
	global running = false
	global asRenderer = undefined
	global cFrame
	global saveFilePath = (GetDir #renderoutput) + "\frame"
	global saveFileExt = ".png"
	global dialogPos
	global startFrame = (animationRange.start as Integer)/160
	global endFrame = (animationRange.end as Integer)/160
	global RenderStartTime
	global LastFrameTime
	Global NewFrameTime
	global LastFrameDuration
	global wholeanim
	global AAthrRTversion 
	global AAShowMaskRTversion
	
	global ConvertDateToMilliseconds
	fn ConvertDateToMilliseconds TheDate =
	(
		TheDay = TheDate[4]
		TheHour = TheDate[5]
		TheMinut = TheDate[6]
		TheSecond = TheDate[7]
		TheMilliSecond = TheDate[8]
		return (TheMilliSecond + (TheSecond * 1000) + (TheMinut * 60000) + (TheHour * 3600000) + (TheDay * 86400000)) as integer
	)
	
	rollout SettingsRollout "V-Ray RT1.9 Anim. Preview Render Settings" width:308 height:260
	(
		
		label startFrameSpinLabel "Start frame:" pos:[16,28] width:64 height:16
		spinner startFrameSpin "" pos:[80,28] width:70 height:16 range:[0, animationRange.end, startFrame] type:#integer scale:1
		label endFrameSpinLabel "End frame:" pos:[164,28] width:56 height:16
		spinner endFrameSpin "" pos:[220,28] width:70 height:16 range:[0, animationRange.end, endFrame] type:#integer scale:1
		label timeLimitSpinLabel "Time limit (min.):" pos:[16,92] width:90 height:16
		spinner timeLimitSpin "" pos:[112,92] width:70 height:16 range:[0.0, 525600.0, asRenderer.max_render_time] type:#float scale:0.25
		label noiseThrLimitSpinLabel "Noise threshold:" pos:[16,132] width:96 height:16
		spinner noiseThrLimitSpin "" pos:[112,132] width:70 height:16 range:[0.00001, 0.99, AAthrRTversion] type:#float scale:0.01
		edittext saveFileNameEdit text:(saveFilePath + saveFileExt) pos:[8,164] width:256 height:17
		button saveFileNameBtn "..." pos:[264,164] width:20 height:18
		button startPreviewBtn "Start Preview Render" pos:[8,190] width:292 height:18
		button cancelPreview "Cancel" pos:[8,212] width:292 height:18
		progressBar animProgress "" pos:[8,236] width:292 height:16
		spinner MaxPathLimitSpin "" pos:[112,112] width:70 height:16 range:[0, 65536, asRenderer.max_paths_per_pixel] type:#integer scale:0.01
		label MaxPathLimitLabel "Max Path per pixel:" pos:[16,112] width:96 height:16
		
		GroupBox grp1 "Animation range" pos:[8,8] width:292 height:48
		GroupBox grp2 "Render limits" pos:[8,64] width:184 height:92
		GroupBox grp3 "Options" pos:[196,64] width:104 height:92
		
		label lbl11 "Show AA Mask:" pos:[204,136] width:76 height:16
		checkbox ShowAACheckBox "" pos:[282,134] width:16 height:20 checked:AAShowMaskRTversion
		checkbox ShowStatsCheckbox "" pos:[282,109] width:16 height:20 checked:asRenderer.showStatistics
		label lbl12 "Show Stats:" pos:[204,112] width:76 height:16
		button BrowseBtn ">" pos:[284,164] width:16 height:18
		
		-- =================== start =================================
		on SettingsRollout open do
		(
			if (startFrame < animationRange.start) do 
			(
				startFrame = animationRange.start
			)
			
			if (endFrame > animationRange.end) do 
			(
				endFrame = animationRange.end
			)
		)
		on SettingsRollout close do
		(
			running = false
		)
		on SettingsRollout moved pos do
		(
			dialogPos = pos
		)
		on startFrameSpin changed val do
		(
			startFrame = val
		)
		on endFrameSpin changed val do
		(
			endFrame = val
		)
		on timeLimitSpin changed val do
		(
			if (enabled) then 
			(
				asRenderer.max_render_time = val
			)
		)
		on noiseThrLimitSpin changed val do
		(
			if (enabled) then 
			(
				try(asRenderer.AAthreshold = val)
				catch(asRenderer.AA_threshold = val)
				
			)
		)
		on MaxPathLimitSpin changed val do
		(
			if (enabled)then 
			(
				asRenderer.max_paths_per_pixel = val
			)
		)
		-- options
		on ShowAACheckBox changed val do
		(
			if (enabled) then
			(
				try(asRenderer.aashowMask = val)catch(asRenderer.aa_showMask = val)
			)
		)
		on ShowStatsCheckbox changed val do
		(
			if (enabled) then
			(
				asRenderer.showStatistics = val
			)
		)
		on saveFileNameEdit changed val do
		(
			saveFilePath = (getFilenamePath val) + (getFilenameFile val)
			saveFileExt = (getFilenameType val)
		)
		on saveFileNameBtn pressed do
		(
			local newFilePath = getSaveFileName filename:saveFileNameEdit.text types:"PNG Image File (*.png)|*.png|JPEG File (*.jpg)|*.jpg"	historyCategory:"MAXScriptFileOpenSave"
			if (newFilePath != undefined) do 
			(
				saveFileNameEdit.text = newFilePath
				saveFilePath = (getFilenamePath newFilePath) + (getFilenameFile newFilePath)
				saveFileExt = (getFilenameType newFilePath)
			)
		)
		on BrowseBtn pressed do
		(
			
			lepath = getFilenamePath saveFileNameEdit.text
			shelllaunch "explorer.exe " lepath
		)
		

		on startPreviewBtn pressed do
		(
			if (running == false) do 
			(
				running = true
				startPreviewBtn.enabled = false
				animProgress.value = 0
				cFrame = startFrame
				saveFilePath = (getFilenamePath saveFileNameEdit.text) + (getFilenameFile saveFileNameEdit.text)
				saveFileExt = (getFilenameType saveFileNameEdit.text)
				
				if (vrayGetRTBitmap() != undefined) then 
				(
					sliderTime = cFrame
					actionMan.executeAction 369690881 "1"	-- reinitialize renderer
				)
				else 
				(
					sliderTime = cFrame
					actionMan.executeAction 0 "40701"	-- start VrayRT ActiveShade
				)
				SettingsRollout.startPreviewBtn.text = "Starting Frame " + (cframe as string)
			)
			WholeAnim = EndFrame - StartFrame
			RenderStartTime = LastFrameTime = ConvertDateToMilliseconds (getlocaltime())
			
		)
		on cancelPreview pressed do
		(
			startPreviewBtn.enabled = true
			running = false
			startPreviewBtn.caption = "Start Preview Render"
		)
		
		
	)
	
	fn checkRenderer = 
	(
		asRenderer = renderers.activeShade
				

		
		if (asRenderer != undefined) then 
		(
			enabled = ((renderers.activeShade.classid[1] == 1770671000) and (renderers.activeShade.classid[2] == 1323107829))
			
		) 
		else 
		(
			enabled = false
		)
		if enabled == true then
		(
			try(AAthrRTversion = asRenderer.AAthreshold)catch(AAthrRTversion = asRenderer.AA_threshold)
			try(AAShowMaskRTversion = asRenderer.aashowMask)catch(AAShowMaskRTversion = asRenderer.aa_showMask)
		)
	)
	
	--on execute do (
		checkRenderer()
	
		
		if (enabled) then 
		(
			if (dialogPos != undefined) then CreateDialog SettingsRollout style:#(#style_titlebar, #style_border, #style_sysmenu) pos:dialogPos modal:true
			else CreateDialog SettingsRollout style:#(#style_titlebar, #style_border, #style_sysmenu) modal:true
			
		)
		else messagebox("Please set Vray-RT as Interactive Viewport first !")
	--)
	
	--on isEnabled do (
--		checkRenderer()
		--enabled
	--)
	
	--on isVisible do (
--		checkRenderer()
		--enabled
	--)

	-- Export function through global variable declaration

	
	global vrayRTImageComplete
	fn vrayRTImageComplete reason = 
	(
		if (running) then
		(	
			NewFrameTime = ConvertDateToMilliseconds (getlocaltime()) -- for time subtraction
			if ((saveFilePath != "") AND (saveFileExt != "")) then
			(
				local b = vrayGetRTBitmap()
				if (b != undefined) do 
				(
					b.filename = (saveFilePath + (formattedPrint (cFrame) format:"04i") + saveFileExt)
					save b
					close b
				)
			)
			
			SettingsRollout.animProgress.value = ((((cFrame - startFrame)+1)*100)/((endFrame - startFrame)+1))
			
			if (cFrame < endFrame) then 
			(
				cFrame += 1
				try(sliderTime = cFrame)catch()
				actionMan.executeAction 369690881 "1"	-- reinitialize renderer
			) else 
			(
				SettingsRollout.startPreviewBtn.enabled = true
				running = false
			)
					-- TIME Estimations by subburb (13/11/2010)
			-- ============================================
			
			-- OK - compute last frame duration
			
						
			LastFrameDuration = NewFrameTime - LastFrameTime
						
			NbMilliseconds = (mod LastFrameDuration 1000) as integer
			LastFrameDuration = (LastFrameDuration / 1000) as integer
			NbSeconds=(mod LastFrameDuration 60) as integer
			LastFrameDuration = (LastFrameDuration / 60) as integer
			NbMinutes=(mod LastFrameDuration 60) as integer
			LastFrameDuration = (LastFrameDuration / 60) as integer
			NbHours=(mod LastFrameDuration 60) as integer
			LastFrameDuration = (LastFrameDuration / 24) as integer
			NbDays = (mod LastFrameDuration 24) as integer
					
			SettingsRollout.startPreviewBtn.text = "F:" + (cframe as string) + " | Last: " 
			if NbDays > 0 then SettingsRollout.startPreviewBtn.text += (NbDays as string) + "d"
			if NbHours > 0 then SettingsRollout.startPreviewBtn.text += (NbHours as string) + "h"
			SettingsRollout.startPreviewBtn.text += (NbMinutes as string) + "m" + (NbSeconds as string) + "s"
			
			
					
			-- OK - compute duration since start
			Animdurationcopy = AnimDuration = NewFrameTime - RenderStartTime
				
			NbMilliseconds = (mod AnimDuration 1000) as integer
			AnimDuration = (AnimDuration / 1000) as integer
			NbSeconds=(mod AnimDuration 60) as integer
			AnimDuration = (AnimDuration / 60) as integer
			NbMinutes=(mod AnimDuration 60) as integer
			AnimDuration = (AnimDuration / 60) as integer
			NbHours=(mod AnimDuration 60) as integer
			AnimDuration = (AnimDuration / 24) as integer
			NbDays = (mod AnimDuration 24) as integer
				
			SettingsRollout.startPreviewBtn.text += " | elapsed: " 
			if NbDays > 0 then SettingsRollout.startPreviewBtn.text += (NbDays as string) + "d"
			if NbHours > 0 then SettingsRollout.startPreviewBtn.text += (NbHours as string) + "h"
			SettingsRollout.startPreviewBtn.text += (NbMinutes as string) + "m" + (NbSeconds as string) + "s"
			-- OK - Compute time remaining
			RemainingFrames = Endframe - cFrame
			
			RemainingTime = 	((Animdurationcopy)/(cframe - startframe)) * (RemainingFrames)
					print "==============="
					print "RemainingTime"
					print RemainingTime
					
			NbMilliseconds = (mod RemainingTime 1000) as integer
			RemainingTime = (RemainingTime / 1000) as integer
			NbSeconds=(mod RemainingTime 60) as integer
			RemainingTime = (RemainingTime / 60) as integer
			NbMinutes=(mod RemainingTime 60) as integer
			RemainingTime = (RemainingTime / 60) as integer
			NbHours=(mod RemainingTime 60) as integer
			RemainingTime = (RemainingTime / 24) as integer
			NbDays = (mod RemainingTime 24) as integer
			
			SettingsRollout.startPreviewBtn.text += " | Remain: " 
			if NbDays > 0 then SettingsRollout.startPreviewBtn.text += (NbDays as string) + "d" 
			if NbHours > 0 then SettingsRollout.startPreviewBtn.text += (NbHours as string) + "h"
			SettingsRollout.startPreviewBtn.text += (NbMinutes as string) + "m" + (NbSeconds as string) + "s"
			LastFrameTime = ConvertDateToMilliseconds (getlocaltime())
		)
		)
	)
